package vm

import (
	"context"
	"github.com/jinzhu/copier"
	"github.com/pkg/errors"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/helper/xerr"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/repository/result"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/utils"
	"gitlink.org.cn/JointCloud/pcm-openstack/openstack"
	"k8s.io/apimachinery/pkg/util/json"

	"gitlink.org.cn/JointCloud/pcm-coordinator/internal/svc"
	"gitlink.org.cn/JointCloud/pcm-coordinator/internal/types"

	"github.com/zeromicro/go-zero/core/logx"
)

type ShowSecurityGroupLogic struct {
	logx.Logger
	ctx    context.Context
	svcCtx *svc.ServiceContext
}

func NewShowSecurityGroupLogic(ctx context.Context, svcCtx *svc.ServiceContext) *ShowSecurityGroupLogic {
	return &ShowSecurityGroupLogic{
		Logger: logx.WithContext(ctx),
		ctx:    ctx,
		svcCtx: svcCtx,
	}
}

func (l *ShowSecurityGroupLogic) ShowSecurityGroup(req *types.ShowSecurityGroupReq) (resp *types.ShowSecurityGroupResp, err error) {
	// todo: add your logic here and delete this line
	ShowSecurityGroupReq := &openstack.ShowSecurityGroupReq{}
	err = copier.CopyWithOption(ShowSecurityGroupReq, req, copier.Option{Converters: utils.Converters})
	ShowSecurityGroupResp, err := l.svcCtx.OpenstackRpc.ShowSecurityGroup(l.ctx, ShowSecurityGroupReq)
	if err != nil {
		return nil, errors.Wrapf(xerr.NewErrMsg("c端创建失败"), "c端创建失败 : %v ,req:%+v", err, req)
	}
	marshal, err := json.Marshal(&ShowSecurityGroupResp)
	if err != nil {
		return nil, result.NewDefaultError(err.Error())
	}
	json.Unmarshal(marshal, &resp)
	err = copier.CopyWithOption(&resp, &ShowSecurityGroupResp, copier.Option{Converters: utils.Converters})
	return resp, err
}
